/*
 * Created on 14-giu-2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package scuola;

import java.security.InvalidParameterException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.Hashtable;

import scuola.Exceptions.*;

/**
 * @author luigi
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class Classe {
	
	private Sezione _sezione;
	private int _anno;
	private Hashtable _studenti;
	private Hashtable _professori;	
	private ArrayList _registro;
	private ConsiglioDiClasse _consiglio;
	
	public Classe(int anno, Hashtable studenti) {
		this( anno);
		_studenti = studenti;
		Enumeration enum = studenti.elements();
		while (enum.hasMoreElements()) {
			aggiungiAlRegistro((Studente)enum.nextElement());
		}
	}
	
	public Classe(int anno) {
		if (anno<0 || anno>5) {
			throw new InvalidParameterException("l'anno di una classe deve essere compreso tra 1 e 5");
		}
		_anno = anno;
		_studenti = new Hashtable();
		_professori = new Hashtable();
		_registro = new ArrayList();
		_consiglio = new ConsiglioDiClasse(this);
	}
	
	public ConsiglioDiClasse getConsiglioDiClasse() {
		return _consiglio;
	}
	
	private void aggiungiAlRegistro(Studente studente) {
/*		if (numeroDiStudenti()==0) {
			_registro.add(studente);
		}
		else
		{
			int i=0;
			do {
				i++;
			} while (!studente.precedeOrdineAlfabetico((Studente)_registro.get(i)) && i<_registro.size()-1);
			if (i==_registro.size()) {
				_registro.add(studente);
			}
			else
			{
				_registro.add(i+1,studente);
			}
		}
*/
		_registro.add(studente);
		Collections.sort(_registro);
	}
	
	private void rimuoviDalRegistro(Studente studente){
		_registro.remove(studente);
		_registro.trimToSize();
/*		if (_registro.size()==0) {
			return;
		} 
		else {
			int i=-1;
			do {
				i++;
			} while (studente.equals((Studente)_registro.get(i)));
			_registro.remove(studente);
		}
*/					
	}
	
	public ArrayList appello() {
		return (ArrayList)_registro.clone();
	}
		
	public Sezione getSezione() {
		return _sezione;
	}
	
	void setSezione(Sezione sezione) {
		_sezione = sezione;
	}
	
	public int getAnno() {
		return _anno;
	}
	
	public String toString() {
		if (_sezione!=null) {
			return _anno + " " + _sezione.getSezione();
		} else {
			return "" + _anno;
		}
	}
	
	public boolean insegnaProfessore(int matricola) {
		Enumeration enum = _professori.elements();
		while (enum.hasMoreElements()) {
			Professore professore = (Professore)enum.nextElement();
			if (professore.getMatricola() == matricola) {
				return true;
			}
		}
		return false;
	}
	
	private boolean insegnaProfessore(Professore professore) {
		Integer iMatricola = new Integer(professore.getMatricola());
		return _professori.containsKey(iMatricola);
	}
	
	public void rimuoviProfessore(Professore professore) {
		rimuoviProfessore(professore.getMatricola());
	}
	
	public void rimuoviProfessore(int matricola) {
		if (!insegnaProfessore(matricola)) 
		{
			throw new ProfessoreNonTrovatoException("il professore con matricola " + matricola + " non  tra quelli che insegnano nella classe: " + this.toString()); 
		}

		Integer iMatricola = new Integer(matricola);
		Professore professore = getProfessore(matricola);
		_professori.remove(iMatricola);
		try {
			professore.rimuoviClasse(this);
		}
		catch (ClasseNonTrovataException e) {
			
		}
	}	
	
	public Professore getProfessore(int matricola) {
		if (!insegnaProfessore(matricola)) {
			throw new ProfessoreNonTrovatoException("il professore con matricola " + matricola + " non  tra quelli che insegnano nella classe: " + this.toString()); 
		}
		Integer iMatricola = new Integer(matricola);
		return (Professore)_professori.get(iMatricola);
	}
	
	public void aggiungiProfessore(Professore professore) {
		if (professore==null) {
			throw new InvalidParameterException("attenzione il professore non pu essere null");
		}
		if (insegnaProfessore(professore)) {
			throw new ProfessoreDuplicatoException("il professore con codice fiscale " + professore.getCodiceFiscale() + "  gi tra quelli che insegnano nella classe: " + this.toString()); 
		}
		//studente.setClasse(this);
		Integer iMatricola = new Integer(professore.getMatricola());
		_professori.put(iMatricola,professore);
		try {
			professore.aggiungiClasse(this);
		}
		catch (ClasseDuplicataException e) {
			
		}
	}
	
	public int numeroDiProfessori() {
		return _professori.size();
	}
	
	public boolean contieneStudente(int matricola) {
		Enumeration enum = _studenti.elements();
		while (enum.hasMoreElements()) {
			Studente studente = (Studente)enum.nextElement();
			if (studente.getMatricola() == matricola) {
				return true;
			}
		}
		return false;
	}
	
	public boolean contieneStudente(Studente studente) {
		Integer iMatricola = new Integer(studente.getMatricola());
		return _studenti.containsKey(iMatricola);
	}
	
	public void rimuoviStudente(Studente studente) {
		rimuoviStudente(studente.getMatricola());
	}
	
	public void rimuoviStudente(int matricola) {
		if (!contieneStudente(matricola)) 
		{
			throw new StudenteNonTrovatoException("lo studente con matricola " + matricola + " non risulta essere pi iscritto alla classe: " + this.toString()); 
		}

		Integer iMatricola = new Integer(matricola);
		Studente studente = getStudente(matricola);
		rimuoviDalRegistro(studente);
		_studenti.remove(iMatricola);
		studente.setClasse(null);
	}	
	
	public Studente getStudente(int matricola) {
		if (!contieneStudente(matricola)) {
			throw new StudenteNonTrovatoException("lo studente con matricola " + matricola + " non risulta essere pi iscritto alla classe: " + this.toString()); 
		}
		Integer iMatricola = new Integer(matricola);
		return (Studente)_studenti.get(iMatricola);
	}
	
	public void aggiungiStudente(Studente studente) {
		if (studente==null) {
			throw new InvalidParameterException("attenzione lo studente non pu essere null");
		}
		if (contieneStudente(studente)) {
			throw new StudenteDuplicatoException("lo studente con codice fiscale " + studente.getCodiceFiscale() + "  gi stato iscritto alla classe: " + this.toString()); 
		}
		if (studente.getClasse()!=null) {
			throw new OperazioneNonConsentitaException("impossibile aggiungere lo studente " + studente.toString() + " alla classe " + toString() + " poich appartiene gi alla classe " + this.toString());
		}
		studente.setClasse(this);
		Integer iMatricola = new Integer(studente.getMatricola());
		_studenti.put(iMatricola,studente);
		aggiungiAlRegistro(studente);
	}
	
	public int numeroDiStudenti() {
		return _studenti.size();
	}
	
	public Enumeration getStudenti() {
		return _studenti.elements();
	}
	
	public Enumeration getProfessori() {
		return _professori.elements();
	}
	
	public boolean validate() {
		return (_studenti.size()>=15 && _studenti.size()<=30 && _professori.size()>=2);
	}
	
	public boolean equals(Object o) {
		if (o instanceof Classe) {
			return equals((Classe)o);
		}
		else {
			return false;
		}		
	}
	
	public boolean equals(Classe classe) {
		if (this.getAnno()==classe.getAnno()) {
			if (this.getSezione()==null || classe.getSezione()==null) {
				return false;
			}
			if (this.getSezione().getSezione()==classe.getSezione().getSezione()) {	
				return true;
			}
			else {
				return false;
			}
		}
		else {
			return false;
		}
			
	}

}